/****************************************************************************************************
*                                                                                                   *
* CDEFTemplate.h -- Copyright Chris Larson (larson@cd.ucla.edu), 1994 - 1995 All Rights Reserved    *
*                                                                                                   *
* Header file for a CDEF shell.                                                                     *
*                                                                                                   *
* This source file and its compiled derivatives may be freely used within any freeware, shareware,  *
* postcardware, beerware, etc. as long as you mention my name in your credits. Neither this source  *
* nor its compiled derivatives are in the public domain and may not be use in any form in public    *
* domain software. Neither this source nor its compiled derivatives may be used in any form in a    *
* commercial product without the expressed, written consent of the author (me).                     *
*                                                                                                   *
* Version 1.0 -- March 10, 1995                                                                     *
*                                                                                                   *
****************************************************************************************************/

// Include Files

#include <Controls.h>
#include <Memory.h>
#include <Types.h>
#include <Windows.h>

// Constants

#define kColorPort	0xC000	// These bits are set in rowBytes if its a CGrafPort.

// Prototypes

pascal long main (short varCode, ControlHandle theControlHandle, short message, long param);

void BeginDraw(ControlHandle theControlHandle, short varCode, short partCode);

void DrawControl(ControlPtr theControl, short varCode, short partCode, CTabPtr windowColorTable,
                 CTabPtr controlColorTable, Boolean inColor);

short FindControlPart(ControlPtr theControl, short varCode, Point hitPoint);

void CalculateControlRegion(ControlPtr theControl, short varCode, RgnHandle theRegion);

void CalculateIndicatorRegion(ControlPtr theControl, short varCode, RgnHandle theRegion);

void InitControl(ControlPtr theControl, short varCode);

void DispControl(ControlPtr theControl, short varCode);

void PositionIndicator(ControlPtr theControl, short varCode, short dv, short dh);

void CalcIndicatorValues(ControlPtr theControl, short varCode, Point hitPoint,
                         IndicatorDragConstraintPtr info);

Boolean CustomDrag(ControlPtr theControl, short varCode, Boolean dragThumb);

void ActionProcedure(ControlPtr theControl, short varCode, short partCode);

RGBColor *FindColorInTable (CTabPtr colorTable, short id);
